package dev.shadowsoffire.apotheosis.ench.enchantments;

import net.minecraft.world.entity.Entity;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.item.ItemEntity;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import dev.shadowsoffire.apotheosis.Apoth;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraft.world.level.ItemLike;
import dev.shadowsoffire.apotheosis.ench.EnchModuleEvents;
import net.minecraft.world.entity.projectile.ThrownTrident;
import net.minecraftforge.event.entity.living.LivingDropsEvent;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.item.enchantment.EnchantmentCategory;
import net.minecraft.world.item.enchantment.Enchantment;

public class SpearfishingEnchant extends Enchantment
{
    public SpearfishingEnchant() {
        super(Enchantment.Rarity.UNCOMMON, EnchantmentCategory.TRIDENT, new EquipmentSlot[] { EquipmentSlot.MAINHAND });
    }
    
    public int m_6183_(final int pEnchantmentLevel) {
        return 12 + (pEnchantmentLevel - 1) * 18;
    }
    
    public int m_6175_(final int pEnchantmentLevel) {
        return 200;
    }
    
    public int m_6586_() {
        return 5;
    }
    
    public void addFishes(final LivingDropsEvent e) {
        final DamageSource src = e.getSource();
        final Entity 7640_ = src.m_7640_();
        if (7640_ instanceof final ThrownTrident trident) {
            if (trident.m_9236_().f_46443_) {
                return;
            }
            final ItemStack triStack = ((EnchModuleEvents.TridentGetter)trident).getTridentItem();
            final int level = triStack.getEnchantmentLevel((Enchantment)this);
            if (trident.f_19796_.m_188501_() < 3.5f * level) {
                final Entity dead = (Entity)e.getEntity();
                e.getDrops().add(new ItemEntity(trident.m_9236_(), dead.m_20185_(), dead.m_20186_(), dead.m_20189_(), new ItemStack((ItemLike)ForgeRegistries.ITEMS.tags().getTag(Apoth.Tags.SPEARFISHING_DROPS).getRandomElement(trident.f_19796_).orElse(Items.f_41852_), 1 + trident.f_19796_.m_188503_(3))));
            }
        }
    }
}
